// M30xDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "M30xDemo.h"
#include "M30xDlg.h"
#include "dbt.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_VALUE_NAME              128

char *ConfigFileName = "LL_USB.CFG";

extern CM30xDemoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM30xDemoDlg dialog

CAboutDlg dlgAbout;


CM30xDemoDlg::CM30xDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CM30xDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CM30xDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	bAboutRemove = FALSE;
}

void CM30xDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CM30xDemoDlg)
	DDX_Control(pDX, IDC_EDIT1, m_add_new_id_edit);
	DDX_Control(pDX, IDC_LIST1, m_dev_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CM30xDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CM30xDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_CONFIG_ADDNEWDEVICE, OnConfigAddnewdevice)
	ON_COMMAND(ID_CONFIG_REMOVEDEVICE, OnConfigRemovedevice)
	ON_BN_CLICKED(IDC_REMV_BTN, OnRemvBtn)
	ON_BN_CLICKED(IDC_ADD_BTN, OnAddBtn)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_HELP_BTN, OnHelpBtn)
	ON_WM_DEVICECHANGE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM30xDemoDlg message handlers

BOOL CM30xDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	
	// TODO: Add extra initialization here
//	ChkDevStatus();
	bTotalDev = ReadConfigFile(ConfigFileName);
	if(!bTotalDev){
		INT whatSel = MessageBox("No device found in config file, Do you want to use Default?","ERROR",MB_YESNO);
		if(whatSel != IDYES){//YES IS NOT SELECTED
			exit(0);
		}
		FILE *cfg_out;
		if ((cfg_out = fopen(ConfigFileName, "w")) != NULL){
			fputs("NOTE: Important information at end of this file.  File created 05-02-2000  14:09:45\n",cfg_out);
			fputs("\n",cfg_out);
			fputs("301\n",cfg_out);
			fputs("\n",cfg_out);
			fputs("0\n",cfg_out);
			fprintf(cfg_out,"1\n");
			fputs("\n",cfg_out);
			fputs("--------->  DEVICE1\n",cfg_out);
			fprintf(cfg_out,"200\n");
			fprintf(cfg_out,"0\n");
			fprintf(cfg_out,"100\n");
			fprintf(cfg_out,"\n");//add a empty line
			bUseDefaultCfg = FALSE;
			fclose(cfg_out);
			bTotalDev = ReadConfigFile(ConfigFileName);//re-read it
		}
	}else{
		m_dev_list.SetCurSel(0);
	}
	if(!bTotalDev) return FALSE;
	theApp.hMainWnd = this->m_hWnd;
	if(!theApp.pDLL_Init(theApp.hMainWnd, ARG_IGNORED, ARG_IGNORED, 
		ARG_IGNORED, &theApp.bNumDevices, &theApp.bDeviceStatus, theApp.p_ConectDevIDList)){
		MessageBox("Failed to call DLL_Init",ERROR,MB_OK);
		return FALSE;
	}
	BYTE i,j;
	for(i = 0; i< bTotalDev; i++){
		theApp.ConectDevIDList[i] = theApp.asConfigData[i].usDevID;
		theApp.CfgDevIDList[i] = theApp.asConfigData[i].usDevID;
	}
	if(!theApp.pDLL_InstanceInitDeviceList(0)){
		MessageBox("Failed to call InstanceInitDeviceList",ERROR,MB_OK);
		return FALSE;
	}
	j = 0xff;
	for(i = 0; i< bTotalDev; i++){
		if(theApp.ConectDevIDList[i] == theApp.CfgDevIDList[i]){
			strTmp.Format("%d Connected",theApp.CfgDevIDList[i]);
			if(j == 0xff) j = i;//remember the first connected device index
		}else{
			strTmp.Format("%d Unavailable",theApp.CfgDevIDList[i]);
			theApp.ConectDevIDList[i] = 0;
		}
		m_dev_list.AddString(strTmp);
		theApp.asConfigData[i].bIsActive = FALSE;
	}
	if(j != 0xff) m_dev_list.SetCurSel(j);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CM30xDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CM30xDemoDlg::OnPaint() 
{
	this->SetWindowPos(&wndTop,0, 0,0,0,SWP_NOSIZE);
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CM30xDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/****************************************************************************
*
*   Function:			OnSelect() 
*	description:		when click SELECT button, create a new CScanDlg
*						if there is no dialog box for this device ID
*						also set up if the board type(M301/M302) based on
*						device ID number
*	input:				
*   output:				
*	global variable:	theApp.m_pScanDlg[bSelected] was created
****************************************************************************/
void CM30xDemoDlg::OnSelect()
{
	// TODO: Add your control notification handler code here
	//before we go any farthur, get latest status first
	BYTE bSelected = m_dev_list.GetCurSel();
	if(!theApp.ConectDevIDList[bSelected]){
		//when device is NOT connected
		MessageBox("The selected device is not connected","ERROR",MB_OK);
		return;
	}
	if(!theApp.asConfigData[bSelected].bIsActive){
		//we create a new dialog window, it should be deleted 
		//when that window is closed and release all memory.
		theApp.m_pScanDlg[bSelected] = new CScanDlg;
		theApp.m_pScanDlg[bSelected]->bIsM302 = (theApp.ConectDevIDList[bSelected] >= 5000l);
		theApp.m_pScanDlg[bSelected]->bDev_index = bSelected;
		if(!theApp.m_pScanDlg[bSelected]->Create(IDD_SCAN_DLG,this)){
			MessageBox("failed to create scan dialog box",NULL,MB_OK);
		}else{
			if(theApp.m_pScanDlg[bSelected]->bIsM302){
				strTmp.Format("%03u",theApp.ConectDevIDList[bSelected]);
			}else{
				strTmp.Format("%03u",theApp.ConectDevIDList[bSelected]);
			}
			theApp.m_pScanDlg[bSelected]->SetWindowText(strTmp);
			theApp.m_pScanDlg[bSelected]->ShowWindow(SW_SHOW);
			theApp.asConfigData[bSelected].bIsActive = TRUE;
			theApp.m_pScanDlg[bSelected]->MyInit();
		}
	}else{
		//the scan window exists, just set it active
		if(theApp.m_pScanDlg[bSelected]->IsIconic()){
			theApp.m_pScanDlg[bSelected]->SetActiveWindow();
			theApp.m_pScanDlg[bSelected]->GetActiveWindow()->BringWindowToTop();
		}
	}
}

/****************************************************************************
*
*   Function:			OnDblclkList1()  
*	description:		Same as OnSelect()
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::OnDblclkList1() 
{
	// TODO: Add your control notification handler code here
	//when double click the device id do OnStart() 
	OnSelect();
}

/****************************************************************************
*
*   Function:			OnFileExit() 
*	description:		Same as "Exit" clicking
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::OnFileExit() 
{
	// TODO: Add your command handler code here
	//exit from the application
	OnOK();
}

/****************************************************************************
*
*   Function:			OnConfigAddnewdevice() 
*	description:		Add one device from the list
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::OnConfigAddnewdevice() 
{
	// TODO: Add your command handler code here
	OnAddBtn();	
}

/****************************************************************************
*
*   Function:			OnConfigRemovedevice() 
*	description:		Remove one device from the list
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::OnConfigRemovedevice() 
{
	// TODO: Add your command handler code here
	OnRemvBtn();	
}


/****************************************************************************
*
*   Function:			ReadConfigFile(char *strFileName)
*	description:		Read configuration file
*						The FORMAT of configuration file MUST meet certain restriction
*						1.Anything after "--------->  DEVICE"
*						will be read as
*						a.DEVID
*						b.chan
*						c.fRate to be compatiable with VB application format
*	input:				char *strFileName
*   output:				BYTE total device number
*	global variable:	
****************************************************************************/
BYTE CM30xDemoDlg::ReadConfigFile(char *strFileName)
{
	BYTE bTotalDev;
	FILE *cfg_in;
	bTotalDev = 0;
	ulCfgHdrLines = 0;
	USHORT i = 0;
	if ((cfg_in = fopen(strFileName, "r")) != NULL){
		while(!feof(cfg_in)){
			fgets(CfgFileContent[i],255,cfg_in);
			if(!strncmp(CfgFileContent[i],"--------->  DEVICE",18)){
				//find --------->  DEVICE string ,then read 3 lines
				//they are ,DEVID,chan, rate
				if(!ulCfgHdrLines){
					i++;
					ulCfgHdrLines = i;
				}
				fgets(CfgFileContent[i],255,cfg_in);
				theApp.asConfigData[bTotalDev].usDevID = (USHORT)atol(CfgFileContent[i]);
				fgets(CfgFileContent[i],255,cfg_in);
				theApp.asConfigData[bTotalDev].bChan = (BYTE)atoi(CfgFileContent[i]);
				fgets(CfgFileContent[i],255,cfg_in);
				theApp.asConfigData[bTotalDev].fRate = atof(CfgFileContent[i]);
				bTotalDev++;
			}else{
				i++;
			}
		}
		fclose(cfg_in);
		return bTotalDev;
	}
	return bTotalDev;
}


/****************************************************************************
*
*   Function:			WriteConfigFile(char *strFileName)
*	description:		Write configuration file
*	input:				char *strFileName,BYTE bTotalDev
*   output:				BYTE total device number
*	global variable:	
****************************************************************************/
BYTE CM30xDemoDlg::WriteConfigFile(char *strFileName,BYTE bTotalDev)
{
	FILE *cfg_out;
	BYTE i;
	if ((cfg_out = fopen(strFileName, "w")) != NULL){
		//Write header first
		for(i = 0; i < ulCfgHdrLines - 1; i++){
			if(i == 5){
				fprintf(cfg_out,"%d\n",bTotalDev);
			}else{
				fputs(CfgFileContent[i],cfg_out);
			}
		}
		//Write all device configuration
		for(BYTE i = 0; i < bTotalDev; i++){
			fputs("--------->  DEVICE",cfg_out);
			fprintf(cfg_out,"%u\n",i + 1);
			fprintf(cfg_out,"%u\n",theApp.asConfigData[i].usDevID);
			fprintf(cfg_out,"%d\n",theApp.asConfigData[i].bChan);
			fprintf(cfg_out,"%f\n",theApp.asConfigData[i].fRate);
			fprintf(cfg_out,"\n");//add a empty line
		}
		fputs("\n ",cfg_out);
		fputs("\n ",cfg_out);
		fputs("\n ",cfg_out);
		fputs("\n ",cfg_out);
		fputs("==  Line descriptions ============\n",cfg_out);
		fputs("*****************************************\n",cfg_out);
		fputs("First line:	Misc notes, and file date. Put anything in this line\n",cfg_out);
		fputs("Second line:	Leave blank or put anything in this line\n",cfg_out);
		fputs("Third line: 	Model number - 301 or 302\n",cfg_out);
		fputs("Fourth line: 	A required placeholder - leave blank\n",cfg_out);
		fputs("Fifth line:	A requaired placeholder (was debug level at one time)\n",cfg_out);
		fputs("Sixth line:	Number of devices\n",cfg_out);
		fputs("Seventh line:	Leave blank or put anything in this line\n",cfg_out);
		fputs("Eighth line:	Leave blank or put anything in this line. I use it to mark start of new device configuration\n",cfg_out);
		fputs("Ninth line:	Starts entries for first device.\n",cfg_out);
		fputs("\n ",cfg_out);
		fputs("Fields for each DEVICE:\n",cfg_out);
		fputs("First entry:    Device ID\n",cfg_out);
		fputs("Second entry:   current channel\n",cfg_out);
		fputs("Third entry: Rate \n",cfg_out);
		fputs("First line after each device entry must be blank or whatever you want to put there, but it must be present\n",cfg_out);
		fputs("After that repeat for another device for the device count listed in fourth line. After listing all devices anything\n",cfg_out);
		fputs("can be inserted into the file (such as I've done with these notes)\n",cfg_out);
		fputs("NOTES:\n",cfg_out);
		fputs("There  MUST  be a Device ID and other parameters for the number of devices listed in second field\n",cfg_out);
		fputs("Application only reads number of fields indicated by  number of devices Second entry\n",cfg_out);
		fputs("\n ",cfg_out);
		fputs("The data in  --------->  DEVICE x lines and single blank line that precedes them are ignored. However\n",cfg_out);
		fputs("they must be present in this file for each  Number of devices  count\n",cfg_out);
		fclose(cfg_out);
		return i;
	}
	return 0;
}


void CM30xDemoDlg::OnAddBtn() 
{
	// TODO: Add your control notification handler code here
	USHORT ulNewID;
	m_add_new_id_edit.GetWindowText(strTmp);
	ulNewID = atoi(strTmp);
	if(CheckDupID(ulNewID)){
		MessageBox("This device ID is already used","ERROR",MB_OK);
		return;
	}
	if((ulNewID > 100) && (ulNewID < 65536)){
		theApp.asConfigData[bTotalDev].usDevID = ulNewID;
		theApp.asConfigData[bTotalDev].bChan = 0;
		theApp.asConfigData[bTotalDev].fRate = 100.0;
		m_dev_list.AddString(strTmp);
		bTotalDev++;
		WriteConfigFile(ConfigFileName,bTotalDev);
		OnReInit();
	}
	m_dev_list.SetCurSel(bTotalDev - 1);
}

/****************************************************************************
*
*   Function:			OnRemvBtn() 
*	description:		Remove one device from the list
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::OnRemvBtn() 

{
	// TODO: Add your control notification handler code here
	//remove device from the configuration file
	BYTE bDevSel;
	bDevSel = m_dev_list.GetCurSel();
	if(theApp.m_pScanDlg[bDevSel]){
		MessageBox("Close this device dialog box first","ERROR",MB_OK);
		return;
	}
	for(BYTE i = bDevSel; i < bTotalDev; i++){
		theApp.asConfigData[i].bChan = theApp.asConfigData[i+1].bChan;
		theApp.asConfigData[i].usDevID = theApp.asConfigData[i+1].usDevID;
		theApp.asConfigData[i].fRate = theApp.asConfigData[i+1].fRate;
	}
	bTotalDev--;
	m_dev_list.ResetContent();
	for(i = 0; i < bTotalDev; i++){
		strTmp.Format("%d",theApp.asConfigData[i].usDevID);
		m_dev_list.AddString(strTmp);
	}
	WriteConfigFile(ConfigFileName,bTotalDev);
	OnReInit();
}


void CM30xDemoDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
	dlgAbout.DoModal();
}

BOOL CM30xDemoDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	OnHelpBtn();
	return TRUE;
}


void CM30xDemoDlg::OnHelpBtn() 
{
	// TODO: Add your control notification handler code here
	CWnd* pMainWnd = AfxGetMainWnd();
	if (pMainWnd != NULL){
			pMainWnd->SendMessage(WM_COMMAND, ID_CONTEXT_HELP);
	}
}

BOOL CM30xDemoDlg::CheckDupID(USHORT ulNewDevID)
{
	BYTE i;
	for(i = 0; i< bTotalDev; i++){
		if(theApp.CfgDevIDList[i] == ulNewDevID) return TRUE;
	}
	return FALSE;
}

void CM30xDemoDlg::OnReInit() 
{
	// TODO: Add your control notification handler code here
	BYTE i,j;
	USHORT usTmpDevList[MAX_NUM_DEVICE];
	for(i = 0; i< bTotalDev; i++){
		theApp.ConectDevIDList[i] = theApp.asConfigData[i].usDevID;
		theApp.CfgDevIDList[i] = theApp.asConfigData[i].usDevID;
	}
	if(!theApp.pDLL_GetDeviceIDList()) return;
	for(i = 0; i < MAX_NUM_DEVICE;i++){
		usTmpDevList[i] = theApp.ConectDevIDList[i];//save it first
		if(theApp.m_pScanDlg[i]){
			if(theApp.m_pScanDlg[i]->bIsScanning){
				theApp.ConectDevIDList[i] = 0;
			}
		}
		//make device ID = 0 for device which is scanning
	}
	if(!theApp.pDLL_InstanceInitDeviceList(0)) return;//call it once
	m_dev_list.ResetContent();
	j = 0xff;
	for(i = 0; i< bTotalDev; i++){
		if(theApp.CfgDevIDList[i] == theApp.ConectDevIDList[i]){
			strTmp.Format("%u Connected",theApp.CfgDevIDList[i]);
			if(j == 0xff) j = i;//remember 1st connected device
		}else{
			if(theApp.m_pScanDlg[i]){
				if(theApp.m_pScanDlg[i]->bIsScanning){
					strTmp.Format("%u Connected",theApp.CfgDevIDList[i]);
					if(j == 0xff) j = i;//remember 1st connected device
				}else{
					strTmp.Format("%u Unavailable",theApp.CfgDevIDList[i]);
				}
			}else{
				strTmp.Format("%u Unavailable",theApp.CfgDevIDList[i]);
			}
		}
		m_dev_list.AddString(strTmp);
	}
	for(i = 0; i < MAX_NUM_DEVICE;i++){
		theApp.ConectDevIDList[i] = usTmpDevList[i];//restore them back
	}
	theApp.asConfigData[i].bIsActive = FALSE;
	if(j != 0xff) m_dev_list.SetCurSel(j);

}

BOOL CM30xDemoDlg::OnDeviceChange(UINT nEventType, DWORD dwData )
{
	if(nEventType == DBT_DEVICEARRIVAL){
		OnReInit();
	}
//	if(nEventType == DBT_DEVNODES_CHANGED) 		ChkDevStatus();
	if((nEventType == DBT_DEVNODES_CHANGED) && bAboutRemove){
		Sleep(3000);
		OnReInit();
	}
	if(nEventType == DBT_DEVICEREMOVECOMPLETE){
		bAboutRemove = TRUE;
	}else{
		bAboutRemove = FALSE;
	}
	return TRUE;
}


/****************************************************************************
*
*   Function:			ChkDevStatus() 
*	description:		Check latest device status(connected/disconnected)
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM30xDemoDlg::ChkDevStatus()
{
	CHAR    ClassName[MAX_PATH] = ""; // Buffer for class name.
	DWORD   dwcClassLen = MAX_PATH;   // Length of class string.
	DWORD   dwcSubKeys;               // Number of sub keys.
	DWORD   dwcMaxSubKey;             // Longest sub key size.
	DWORD   dwcMaxClass;              // Longest class string.
	DWORD   dwcValues;                // Number of values for this key.
	DWORD   dwcMaxValueName;          // Longest Value name.
	DWORD   dwcMaxValueData;          // Longest Value data.
	DWORD   dwcSecDesc;               // Security descriptor.
	FILETIME	ftLastWriteTime;          // Last write time.
	BYTE	bData[255];
    CHAR	ValueName[MAX_VALUE_NAME];
	DWORD	cbValueName = MAX_VALUE_NAME;
	DWORD	dwType;
	HKEY	hKey;
    DWORD	retCode;	
	HKEY	hKeyRoot;
	hKeyRoot = HKEY_LOCAL_MACHINE;
	CHAR RegPath[MAX_PATH] = "System\\M301Devices";
	retCode = RegOpenKeyEx (hKeyRoot,
						  RegPath,
						  0,
						  KEY_ENUMERATE_SUB_KEYS |
						  KEY_EXECUTE |
						  KEY_QUERY_VALUE,
						  &hKey);
	RegCloseKey (hKey);   // Close the key handle.
    if (retCode != ERROR_SUCCESS) return;//failed to make the call

// ADD A QUERY AND ALLOCATE A BUFFER FOR BDATA.
	  retCode =  RegQueryInfoKey (hKey,              // Key handle.
					   ClassName,         // Buffer for class name.
					   &dwcClassLen,      // Length of class string.
					   NULL,              // Reserved.
					   &dwcSubKeys,       // Number of sub keys.
					   &dwcMaxSubKey,     // Longest sub key size.
					   &dwcMaxClass,      // Longest class string.
					   &dwcValues,        // Number of values for this key.
					   &dwcMaxValueName,  // Longest Value name.
					   &dwcMaxValueData,  // Longest Value data.
					   &dwcSecDesc,       // Security descriptor.
					   &ftLastWriteTime); // Last write time.
    if (retCode != ERROR_SUCCESS) return;//failed to make the call
	// ENUMERATE THE KEY.
	retCode = RegEnumValue (hKey,        // Key handle returned from RegOpenKeyEx.
						  0,   // Value index, taken from listbox.
						  ValueName,   // Name of value.
						  &cbValueName,// Size of value name.
						  NULL,        // Reserved, dword = NULL.
						  &dwType,     // Type of data.
						  bData,       // Data buffer.
						  &dwcMaxValueData);    // Size of data buffer.
    if (retCode != ERROR_SUCCESS) return;//failed to make the call
	//now bData[] has last information about all devices.
}
