// ScanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "M30xDemo.h"
#include "ScanDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char ERROR_MSG[50][50] = {
	"COMMAND_SUCCESS",
	"CALIBRATE_DEV_FAILED",
	"CHECK_DLL_LIBRARY_FAILED",
	"DEV_TIME_OUT",
	"DEV_WAS_REMOVED",
	"DEV_INVALID_ID_ENTRY",
	"DEV_NOT_IN_LIST",
	"DLL_FAILED",
	"FIND_FUNCTION_IN_DLL_FAILED",
	"GET_ECHO_FAILED",
	"INIT_DEV_FAILED",
	"INVALID_DEV_ID",
	"INVALID_DEV_RESPONSE",
	"INVALID_ARGUMENT",
	"INIT_DEV_SUCCESS",
	"LOAD_DLL_LIBRARY_FAILED",
	"MEMORY_ALLOC_FAILED",
	"RESET_DEV_FAILED",
	"READ_CONFIG_FILE_FAILED",
	"REINIT_DEV_FAILED",
	"READ_CONVERSION_FAILED",
	"REV_DATA_FAILED",
	"SCAN_HALTED_ERR",
	"SEND_CMD_FAILED",
	"SEND_DATA_FAILED",
	"SIGNON_DEV_FAILED",
	"SIGN_ON_SUCCESS",
	"SET_RATE_FAILED",
	"SET_DLL_APP_MSG_FAILED",
	"VERIFY_CHKSUM_FAILED",
	"VERIFY_DEV_FAILED",
	"DEV_NO_POWER"
};

extern CM30xDemoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CScanDlg dialog
/****************************************************************************
*
*   Function:			CScanDlg() 
*	description:		Constructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/

CScanDlg::CScanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScanDlg)
	//}}AFX_DATA_INIT
	InitAllFonts();
	m_pFont1 = new CFont();
	m_pFont1->CreateFontIndirect(&m_Font1);
	m_pFont2 = new CFont();
	m_pFont2->CreateFontIndirect(&m_Font2);
	ulTotalLogLines = 0;
	m_bkColor0 = RGB(128,255,255);
	bkBrush.CreateSolidBrush(m_bkColor0);
	m_pRedPen = new CPen(PS_SOLID,1,RGB(0xff,0,0));
	m_pYlwPen = new CPen(PS_SOLID,1,RGB(200,250,10));
	m_pWhitePen = new CPen(PS_SOLID,1,RGB(0xff,0xff,0xff));
}

/****************************************************************************
*
*   Function:			~CScanDlg() 
*	description:		Destructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
CScanDlg::~CScanDlg()
{
	if(m_pFont1) delete m_pFont1;
	if(m_pFont2) delete m_pFont2;
	if(m_pRedPen) delete m_pRedPen;
	if(m_pYlwPen) delete m_pYlwPen;
	if(m_pWhitePen) delete m_pWhitePen;
}

/****************************************************************************
*
*   Function:			DoDataExchange() 
*	description:		MFC standard function
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScanDlg)
	DDX_Control(pDX, IDC_RATE_EDIT, m_rate_edit);
	DDX_Control(pDX, IDC_SCAN_LOG_FILE, m_scan_log_check);
	DDX_Control(pDX, IDC_DATA_POINTS, m_data_points);
	DDX_Control(pDX, IDC_LED_RED8, m_led_red8);
	DDX_Control(pDX, IDC_LED_RED7, m_led_red7);
	DDX_Control(pDX, IDC_LED_RED6, m_led_red6);
	DDX_Control(pDX, IDC_LED_RED5, m_led_red5);
	DDX_Control(pDX, IDC_LED_RED4, m_led_red4);
	DDX_Control(pDX, IDC_LED_RED3, m_led_red3);
	DDX_Control(pDX, IDC_LED_RED2, m_led_red2);
	DDX_Control(pDX, IDC_LED_RED1, m_led_red1);
	DDX_Control(pDX, IDC_LED_GRAY8, m_led_gray8);
	DDX_Control(pDX, IDC_LED_GRAY7, m_led_gray7);
	DDX_Control(pDX, IDC_LED_GRAY6, m_led_gray6);
	DDX_Control(pDX, IDC_LED_GRAY5, m_led_gray5);
	DDX_Control(pDX, IDC_LED_GRAY4, m_led_gray4);
	DDX_Control(pDX, IDC_LED_GRAY3, m_led_gray3);
	DDX_Control(pDX, IDC_LED_GRAY2, m_led_gray2);
	DDX_Control(pDX, IDC_LED_GRAY1, m_led_gray1);
	DDX_Control(pDX, IDC_SCAN_RATE, m_scan_rate);
	DDX_Control(pDX, IDC_SEC_P_DIV, m_sec_p_div);
	DDX_Control(pDX, IDC_DC_AC, m_dc_ac_sel);
	DDX_Control(pDX, IDC_CHAN_SEL, m_chan_sel);
	DDX_Control(pDX, IDC_CAL_SCAN, m_cal_scan);
	DDX_Control(pDX, IDC_NUM_CHAN, m_num_scan_chan);
	DDX_Control(pDX, IDC_VOLT_DIV_COMBO, m_volt_div_combo);
	DDX_Control(pDX, IDC_LCD_SCRN, m_lcd_screen);
	DDX_Control(pDX, IDC_AVG_COMBO, m_avg_combo);
	DDX_Control(pDX, IDC_INITIALIZATION, m_initialization);
	DDX_Control(pDX, IDC_MULTI_CHAN, m_multi_chan);
	DDX_Control(pDX, IDC_DO_D0, m_do_d0);
	DDX_Control(pDX, IDC_DO_D1, m_do_d1);
	DDX_Control(pDX, IDC_DO_D2, m_do_d2);
	DDX_Control(pDX, IDC_DO_D3, m_do_d3);
	DDX_Control(pDX, IDC_DO_D4, m_do_d4);
	DDX_Control(pDX, IDC_DO_D5, m_do_d5);
	DDX_Control(pDX, IDC_DO_D6, m_do_d6);
	DDX_Control(pDX, IDC_DO_D7, m_do_d7);
	DDX_Control(pDX, IDC_V0, m_read_v0);
	DDX_Control(pDX, IDC_V1, m_read_v1);
	DDX_Control(pDX, IDC_V2, m_read_v2);
	DDX_Control(pDX, IDC_V3, m_read_v3);
	DDX_Control(pDX, IDC_V4, m_read_v4);
	DDX_Control(pDX, IDC_V5, m_read_v5);
	DDX_Control(pDX, IDC_V6, m_read_v6);
	DDX_Control(pDX, IDC_V7, m_read_v7);
	DDX_Control(pDX, IDC_CH0, m_sel_ch0);
	DDX_Control(pDX, IDC_CH1, m_sel_ch1);
	DDX_Control(pDX, IDC_CH2, m_sel_ch2);
	DDX_Control(pDX, IDC_CH3, m_sel_ch3);
	DDX_Control(pDX, IDC_CH4, m_sel_ch4);
	DDX_Control(pDX, IDC_CH5, m_sel_ch5);
	DDX_Control(pDX, IDC_CH6, m_sel_ch6);
	DDX_Control(pDX, IDC_CH7, m_sel_ch7);
	DDX_Control(pDX, IDC_DAC0_OUTPUT, m_dac_out_btn0);
	DDX_Control(pDX, IDC_DAC1_OUTPUT, m_dac_out_btn1);
	DDX_Control(pDX, IDC_DAC2_OUTPUT, m_dac_out_btn2);
	DDX_Control(pDX, IDC_DAC0_EDIT, m_dac_edit0);
	DDX_Control(pDX, IDC_DAC1_EDIT, m_dac_edit1);
	DDX_Control(pDX, IDC_DAC2_EDIT, m_dac_edit2);
	DDX_Control(pDX, IDC_END_SCAN, m_end_scan);
	DDX_Control(pDX, IDC_SYS_CAL, m_sys_cal);
	DDX_Control(pDX, IDC_DBG_LEVEL, m_dbg_level);
	DDX_Control(pDX, IDC_START_SCAN, m_start_scan);
	DDX_Control(pDX, IDC_EVENT_LOG, m_evt_log_wnd);
	DDX_Control(pDX, IDC_POLL_MODE, m_poll_mode);
	DDX_Control(pDX, IDC_SCAN_MODE, m_scan_mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScanDlg, CDialog)
	//{{AFX_MSG_MAP(CScanDlg)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_START_SCAN, OnStartScan)
	ON_BN_CLICKED(IDC_INITIALIZATION, OnInitialization)
	ON_BN_CLICKED(IDC_POLL_MODE, OnPollMode)
	ON_BN_CLICKED(IDC_SCAN_MODE, OnScanMode)
	ON_BN_CLICKED(IDC_CH0, OnCh0)
	ON_BN_CLICKED(IDC_CH1, OnCh1)
	ON_BN_CLICKED(IDC_CH2, OnCh2)
	ON_BN_CLICKED(IDC_CH3, OnCh3)
	ON_BN_CLICKED(IDC_CH4, OnCh4)
	ON_BN_CLICKED(IDC_CH5, OnCh5)
	ON_BN_CLICKED(IDC_CH6, OnCh6)
	ON_BN_CLICKED(IDC_CH7, OnCh7)
	ON_BN_CLICKED(IDC_END_SCAN, OnEndScan)
	ON_BN_CLICKED(IDC_DO_D7, OnDoD7)
	ON_BN_CLICKED(IDC_DO_D6, OnDoD6)
	ON_BN_CLICKED(IDC_DO_D5, OnDoD5)
	ON_BN_CLICKED(IDC_DO_D4, OnDoD4)
	ON_BN_CLICKED(IDC_DO_D3, OnDoD3)
	ON_BN_CLICKED(IDC_DO_D2, OnDoD2)
	ON_BN_CLICKED(IDC_DO_D1, OnDoD1)
	ON_BN_CLICKED(IDC_DO_D0, OnDoD0)
	ON_BN_CLICKED(IDC_MULTI_CHAN, OnMultiChan)
	ON_CBN_SELCHANGE(IDC_AVG_COMBO, OnSelchangeAvgCombo)
	ON_BN_CLICKED(IDC_SYS_CAL, OnSysCal)
	ON_CBN_SELCHANGE(IDC_VOLT_DIV_COMBO, OnSelChangVoltDivComb)
	ON_CBN_SELCHANGE(IDC_DC_AC,OnSelChangDcAcComb)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CAL_SCAN, OnCalScan)
	ON_CBN_SELCHANGE(IDC_NUM_CHAN, OnSelchangeNumChan)
	ON_BN_CLICKED(IDC_DAC0_OUTPUT, OnDac0Output)
	ON_BN_CLICKED(IDC_DAC1_OUTPUT, OnDac1Output)
	ON_BN_CLICKED(IDC_DAC2_OUTPUT, OnDac2Output)
	ON_WM_HELPINFO()
	ON_CBN_SELCHANGE(IDC_CHAN_SEL, OnSelchangeChanSel)
	ON_BN_CLICKED(IDEXIT, OnExit)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/****************************************************************************
*
*   Function:			OnInitDialog()
*	description:		When Dialog box is about created.
*						This function is called only once
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
BOOL CScanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	this->SetWindowPos(&wndTop,30 + bDev_index * 20, 30 + 20 *bDev_index,
			0,0,SWP_NOSIZE);
	m_poll_mode.SetCheck(1);	//init mode
	m_scan_mode.SetCheck(0);
	bInitializedOK = FALSE;
	bIsScanning = FALSE;
	m_pChanSel[0] = &m_sel_ch0;
	m_pChanSel[1] = &m_sel_ch1;
	m_pChanSel[2] = &m_sel_ch2;
	m_pChanSel[3] = &m_sel_ch3;
	m_pChanSel[4] = &m_sel_ch4;
	m_pChanSel[5] = &m_sel_ch5;
	m_pChanSel[6] = &m_sel_ch6;
	m_pChanSel[7] = &m_sel_ch7;

	m_pChanReading[0] = &m_read_v0;
	m_pChanReading[1] = &m_read_v1;
	m_pChanReading[2] = &m_read_v2;
	m_pChanReading[3] = &m_read_v3;
	m_pChanReading[4] = &m_read_v4;
	m_pChanReading[5] = &m_read_v5;
	m_pChanReading[6] = &m_read_v6;
	m_pChanReading[7] = &m_read_v7;
	
	m_pDigiOut[0] = &m_do_d0;
	m_pDigiOut[1] = &m_do_d1;
	m_pDigiOut[2] = &m_do_d2;
	m_pDigiOut[3] = &m_do_d3;
	m_pDigiOut[4] = &m_do_d4;
	m_pDigiOut[5] = &m_do_d5;
	m_pDigiOut[6] = &m_do_d6;
	m_pDigiOut[7] = &m_do_d7;

	BYTE i,bTotalSel;
	for(i = 0; i < 8; i++){
		m_pChanReading[i]->SetFont(m_pFont1,TRUE);
	}
	bTotalSel = 4;
	if(bIsM302) bTotalSel = bTotalSel + 4;
	m_num_scan_chan.ResetContent();
	for(i = 0; i < bTotalSel; i++){
		TmpStr.Format("%d",i+1);
		m_num_scan_chan.AddString(TmpStr);
	}
	m_avg_combo.SetCurSel(2);
	bChanScanAvg = 1 << m_avg_combo.GetCurSel();
	m_num_scan_chan.SetCurSel(0);//'1' is selected
	m_num_scan_chan.EnableWindow(FALSE);
	p_LCD_CDC = m_lcd_screen.GetDC();
	m_lcd_screen.GetClientRect(&LCD_RECT);
	ulDotsPerScaleY = (UINT)(LCD_RECT.bottom / 10);
	ulDotsPerScaleX = (UINT)(LCD_RECT.right / 10);
	p_LCD_CDC->SetBkColor(m_bkColor0);
	p_LCD_CDC->FillRect(&LCD_RECT,&bkBrush);
	ulCenter = LCD_RECT.bottom / 2;
	m_lcd_screen.Invalidate();
	m_cal_scan.ShowWindow(SW_HIDE);
	bDbgLvl = (BYTE) GetPrivateProfileInt("LL_USB", "DebugLvl", 0, "LL_USB.ini");
	if(bDbgLvl > 6) bDbgLvl = 6;
	TmpStr.Format("%d",bDbgLvl);
	m_dac_out_btn0.EnableWindow(bIsM302);
	m_dac_out_btn1.EnableWindow(bIsM302);
	m_dac_out_btn2.EnableWindow(bIsM302);
	m_dac_edit0.EnableWindow(bIsM302);
	m_dac_edit1.EnableWindow(bIsM302);
	m_dac_edit2.EnableWindow(bIsM302);
	m_dbg_level.SetWindowText(TmpStr);
	m_dc_ac_sel.SetCurSel(0);//select DC input for default
	m_chan_sel.SetCurSel(0);//select channel 0
	m_volt_div_combo.SetCurSel(6);//select 1mV 
	bIsAC = (m_dc_ac_sel.GetCurSel() == 1);
	OnSelChangVoltDivComb();
	fOffSet = 0;
	if(m_multi_chan.GetCheck()){
		m_chan_sel.EnableWindow(TRUE);
	}else{
		m_chan_sel.EnableWindow(FALSE);
	}
	if((theApp.asConfigData[bDev_index].fRate >= 50) &&
		(theApp.asConfigData[bDev_index].fRate <= 1001)){
		TmpStr.Format("%5.1f",theApp.asConfigData[bDev_index].fRate);
		m_rate_edit.SetWindowText(TmpStr);
		apScanObject.SO_dblRate = theApp.asConfigData[bDev_index].fRate;
	}else{
		TmpStr.Format("100.0");//use default
		m_rate_edit.SetWindowText(TmpStr);
		apScanObject.SO_dblRate = 100.0;
	}
	if(theApp.asConfigData[bDev_index].bChan < 8){
		bCurSelChan = theApp.asConfigData[bDev_index].bChan;
	}else{
		bCurSelChan = 0;
	}
	m_pChanSel[bCurSelChan]->SetCheck(1);
	CalNumOfChan();
	pLogFile = NULL;//init value;
	OnPollMode();
	return TRUE;
}

/****************************************************************************
*
*   Function:			UpdateWndState() 
*	description:		Update the dialog box display(disable/enable some buttons)
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::UpdateWndState(BOOLEAN bInitOK)
{
	BYTE i;
	m_start_scan.EnableWindow(bInitOK);
	if(m_start_scan.IsWindowEnabled()){
		m_end_scan.EnableWindow(FALSE);
	}else{
		m_end_scan.EnableWindow(bInitOK);
	}
	m_sys_cal.EnableWindow(bInitOK);
	for(i = 0; i < 8; i++){
		m_pChanSel[i]->EnableWindow(bInitOK);
		m_pDigiOut[i]->EnableWindow(bInitOK);
	}
	if(bIsM302){
		m_dac_edit0.EnableWindow(bInitOK);
		m_dac_edit1.EnableWindow(bInitOK);
		m_dac_edit2.EnableWindow(bInitOK);
		m_dac_out_btn0.EnableWindow(bInitOK);
		m_dac_out_btn1.EnableWindow(bInitOK);
		m_dac_out_btn2.EnableWindow(bInitOK);
	}else{
		m_dac_edit0.EnableWindow(FALSE);
		m_dac_edit1.EnableWindow(FALSE);
		m_dac_edit2.EnableWindow(FALSE);
		m_dac_out_btn0.EnableWindow(FALSE);
		m_dac_out_btn1.EnableWindow(FALSE);
		m_dac_out_btn2.EnableWindow(FALSE);
		m_pChanSel[2]->EnableWindow(FALSE);
		m_pChanSel[3]->EnableWindow(FALSE);
		m_pChanSel[4]->EnableWindow(FALSE);
		m_pChanSel[5]->EnableWindow(FALSE);
	}
	if(m_scan_mode.GetCheck()){
		m_avg_combo.EnableWindow(bInitOK);
		m_multi_chan.EnableWindow(bInitOK);
	}else{
		m_avg_combo.EnableWindow(FALSE);
		m_multi_chan.EnableWindow(FALSE);
	}
}

/****************************************************************************
*
*   Function:			InitAllFonts() 
*	description:		Initialize all fonts used for the dialog
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::InitAllFonts()
{
	m_Font1.lfHeight = 20;
    m_Font1.lfWidth = 0;
    m_Font1.lfEscapement = 0;
    m_Font1.lfOrientation = 0;
    m_Font1.lfWeight = FW_NORMAL;
    m_Font1.lfItalic = 0;
    m_Font1.lfUnderline = 0;
    m_Font1.lfStrikeOut = 0;
    m_Font1.lfCharSet = ANSI_CHARSET;
    m_Font1.lfOutPrecision = OUT_DEFAULT_PRECIS;
    m_Font1.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    m_Font1.lfQuality = PROOF_QUALITY;
    m_Font1.lfPitchAndFamily = VARIABLE_PITCH | FF_DONTCARE;
	lstrcpy(m_Font1.lfFaceName, "MS Sans Serif");
	m_Font2.lfHeight = 15;
    m_Font2.lfWidth = 0;
    m_Font2.lfEscapement = 0;
    m_Font2.lfOrientation = 0;
    m_Font2.lfWeight = FW_BOLD;
    m_Font2.lfItalic = 0;
    m_Font2.lfUnderline = 0;
    m_Font2.lfStrikeOut = 0;
    m_Font2.lfCharSet = ANSI_CHARSET;
    m_Font2.lfOutPrecision = OUT_DEFAULT_PRECIS;
    m_Font2.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    m_Font2.lfQuality = PROOF_QUALITY;
    m_Font2.lfPitchAndFamily = VARIABLE_PITCH | FF_DONTCARE;
	lstrcpy(m_Font2.lfFaceName, "MS Sans Serif");
}


/****************************************************************************
*
*   Function:			PrepScanObj() 
*	description:		Preparation of scan object 
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::PrepScanObj()
{
	apScanObject.SO_uiStatus = 0;
	apScanObject.SO_uiCurHead = 0;
	apScanObject.SO_uiCurTail = 0;
	apScanObject.SO_uiPointsInBuffer = 0;
	apScanObject.SO_uiTotalPointsReadByDrvr = 0;
	apScanObject.SO_bDeviceDisconnect = 0;
	apScanObject.SO_uiSizeVoltageArray = VOLTAGE_ARRAY_SIZE;
	apScanObject.SO_bChecksum = 0;
	apScanObject.SO_clkScanEndTime = 0;
	apScanObject.SO_clkScanStartTime = 0;
	apScanObject.SO_bDigitalInput = 0;
	if(!m_multi_chan.GetCheck()){
		apScanObject.SO_bScanType = SINGLE_CHAN_DIGIN_SCAN;
	}else{
		if(!m_cal_scan.GetCheck()){
			apScanObject.SO_bScanType = MULTI_CHAN_DIGIN_SCAN;
		}else{
			apScanObject.SO_bScanType = MULTI_CHAN_CAL_DIGIN_SCAN;
		}
	}
	apScanObject.SO_bScanArg = bNumChanScan - (m_cal_scan.GetCheck() & 1);
}


/****************************************************************************
*
*   Function:			OnPaint() 
*	description:		when the dialog box is re-drawn
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	ClsScreen();	
	// TODO: Add your message handler code here
	CDialog::OnPaint();
}

/****************************************************************************
*
*   Function:			PostNcDestroy() 
*	description:		when this dialog box is about destroied
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::PostNcDestroy()
{
	theApp.m_pScanDlg[bDev_index] = NULL;
	delete this;
}


/****************************************************************************
*
*   Function:			OnTimerProc() 
*	description:		When time interval interrupt occurs
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CALLBACK CScanDlg::OnTimerProc(
    HWND  hwnd,	// handle of window for timer messages
    UINT  uMsg,	// WM_TIMER message
    UINT  idEvent,	// timer identifier
    DWORD  dwTime 	// current system time
   )
{
	BYTE i;
	for(i = 0; i < MAX_NUM_DEVICE; i++){
		if(theApp.m_pScanDlg[i]){
			if(idEvent == (UINT)theApp.m_pScanDlg[i]->bDev_index){
				theApp.m_pScanDlg[i]->ScheduleAction_O(theApp.m_pScanDlg[i]->bDev_index);
			}
			if(idEvent == (UINT)(theApp.m_pScanDlg[i]->bDev_index | 0x100)){
				theApp.m_pScanDlg[i]->ScheduleAction_I(theApp.m_pScanDlg[i]->bDev_index);
			}
			if(idEvent == (UINT)(theApp.m_pScanDlg[i]->bDev_index | 0x200)){
				theApp.m_pScanDlg[i]->ScheduleAction_II(theApp.m_pScanDlg[i]->bDev_index);
			}
		}
	}
}

/****************************************************************************
*
*   Function:			CheckScanFlg()
*	description:		When DLL_ReadScanDataWithDigin returns FALSE
*						
*	input:				
*   output:				TRUE/FALSE
*	global variable:	
****************************************************************************/
BOOLEAN CScanDlg::CheckScanFlg()
{
	if(!apScanObject.SO_uiStatus) return FALSE;
	if(apScanObject.SO_uiStatus == SCAN_DATA_REQUEST_SUCCEEDED) return FALSE;
	if(apScanObject.SO_uiStatus == SCAN_RUNNING) return FALSE;
	if(apScanObject.SO_uiStatus & SCAN_HALTED){
		TmpStr.Format("Scan halted!!!");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	TmpStr.Format("SO_uiStatus = %x",apScanObject.SO_uiStatus);
	AddEvtLog(&TmpStr);
	if(apScanObject.SO_uiStatus & SCAN_DEVICE_REMOVED){
		TmpStr.Format("Board[%u] is disconnected",theApp.ConectDevIDList[bDev_index]);
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	if(apScanObject.SO_uiStatus & SCAN_MICRO_CODE_BUFF_WRAP){
		TmpStr.Format("SCAN_MICRO_CODE_BUFF_WRAP");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	if(apScanObject.SO_uiStatus & SCAN_CHECKSUM_ERROR){
		TmpStr.Format("SCAN_CHECKSUM_ERROR");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	if(apScanObject.SO_uiStatus & SCAN_DEVICE_IO_ERROR){
		TmpStr.Format("SCAN_DEVICE_IO_ERROR");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	if(apScanObject.SO_uiStatus & SCAN_DEVICE_NOT_FOUND){
		TmpStr.Format("SCAN_DEVICE_NOT_FOUND");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	if(apScanObject.SO_uiStatus & SCAN_VOLTAGE_BUFFER_WRAP){
		TmpStr.Format("SCAN_VOLTAGE_BUFFER_WRAP");
		AddEvtLog(&TmpStr);
		EndScanBtnProc();
		UpdateWndState(FALSE);
	}
	return TRUE;
}

/****************************************************************************
*
*   Function:			OnHelpInfo(HELPINFO* pHelpInfo) 
*	description:		When F1 is pressed (asking for help)
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
BOOL CScanDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CWnd* pMainWnd = AfxGetMainWnd();
	if (pMainWnd != NULL){
			pMainWnd->SendMessage(WM_COMMAND, ID_CONTEXT_HELP);
	}
	return TRUE;
}


/****************************************************************************
*
*   Function:			OnSelchangeChanSel() 
*	description:		When Plot screen channel selection is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSelchangeChanSel() 
{
	// TODO: Add your control notification handler code here
	ClsScreen();
}

/****************************************************************************
*
*   Function:			ClsScreen()
*	description:		Clean Plot screen
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::ClsScreen()
{
	BYTE i,j;
	UINT x,y;
	p_LCD_CDC->FillRect(&LCD_RECT,&bkBrush);
	p_LCD_CDC->SelectObject(m_pYlwPen);
	y = ulDotsPerScaleY + 3;
	x = ulDotsPerScaleX;
	p_LCD_CDC->SetTextColor (RGB(200,250,10));
	for(i = 1; i < 10;i++){
		for(j = 1; j < 10;j++){
			p_LCD_CDC->SetPixel(x,y,RGB(0,0,0));
			x = x + ulDotsPerScaleX;
		}
		x = ulDotsPerScaleX;
		y = y + ulDotsPerScaleY;
	}
	nPlot_X = 0;//start over
	fOffSet = 0;
}



/****************************************************************************
*
*   Function:			WriteDataLogFile(BYTE bWhatChan,UINT ulDataIndex,BYTE bTotalChans)
*	description:		Write data to log file
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::WriteDataLogFile(BYTE bWhatChan,UINT ulDataIndex,BYTE bTotalChans)
{
	UINT k;
	char  strTmp[10];
	BYTE bDigIn;
	bDigIn = myCM30xFun.bDiginBuff[ulDataIndex];
	bDigIn = 0xff - bDigIn;
	if(bIsM302) bDigIn = bDigIn & 0x0f;
	if(!pLogFile) return;//don't do the rest
	if(!m_multi_chan.GetCheck()){//single channel scan
		if(!fprintf(pLogFile,"%u\t%u\t(%d)\t%f\t[%02x]\n",
			theApp.ConectDevIDList[bDev_index],ulScanCnt,
			bWhatChan,fVoltBuff[bWhatChan][ulDataIndex],bDigIn)){
			fclose(pLogFile);//when failed to write
			pLogFile = NULL;//when failed to write
			return;
		}
		return;
	}
	//for multi channel
	if(!fprintf(pLogFile,"%u\t%u\t",theApp.ConectDevIDList[bDev_index],ulScanCnt)){
		fclose(pLogFile);//when failed to write
		pLogFile = NULL;//when failed to write
		return;
	}
	for(k = 0; k < bTotalChans; k++){
		if(m_cal_scan.GetCheck() && (k == (UINT)(bTotalChans -1))){
			sprintf(strTmp,"Offset");
		}else{
			if(!bIsM302){
				switch(k){
					case 2:
						sprintf(strTmp,"6");
						break;
					case 3:
						if(m_cal_scan.GetCheck()){
							sprintf(strTmp,"Offset");
						}else{
							sprintf(strTmp,"7");
						}
						break;
					default:
						sprintf(strTmp,"%d",k);
						break;
				}
			}else{
				if(k == 7){
					if(m_cal_scan.GetCheck()){
						sprintf(strTmp,"Offset");
					}else{
						sprintf(strTmp,"7");
					}
				}else{
					sprintf(strTmp,"%d",k);
				}
			}
		}
		if(!fprintf(pLogFile,"(%s)\t%f\t[%02x]\t", strTmp,fVoltBuff[k][ulDataIndex],bDigIn)){
			fclose(pLogFile);//when failed to write
			pLogFile = NULL;//when failed to write
			return;
		}
	}
	if(!fprintf(pLogFile,"\n")){
		fclose(pLogFile);//when failed to write
		pLogFile = NULL;//when failed to write
		return;
	}
}

void CScanDlg::OnCh0() 
{
	// TODO: Add your control notification handler code here
	//click channel 0 check box
	OnChComm(0);
}

void CScanDlg::OnCh1() 
{
	// TODO: Add your control notification handler code here
	OnChComm(1);
}

void CScanDlg::OnCh2() 
{
	// TODO: Add your control notification handler code here
	OnChComm(2);
}

void CScanDlg::OnCh3() 
{
	// TODO: Add your control notification handler code here
	OnChComm(3);
}

void CScanDlg::OnCh4() 
{
	// TODO: Add your control notification handler code here
	OnChComm(4);	
}

void CScanDlg::OnCh5() 
{
	// TODO: Add your control notification handler code here
	OnChComm(5);
}

void CScanDlg::OnCh6() 
{
	// TODO: Add your control notification handler code here
	OnChComm(6);	
}

void CScanDlg::OnCh7() 
{
	// TODO: Add your control notification handler code here
	OnChComm(7);	
}


void CScanDlg::OnDoD7() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	

}

void CScanDlg::OnDoD6() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CScanDlg::OnDoD5() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CScanDlg::OnDoD4() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CScanDlg::OnDoD3() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CScanDlg::OnDoD2() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CScanDlg::OnDoD1() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
}

void CScanDlg::OnDoD0() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
}

/****************************************************************************
*
*   Function:			OnOK()
*	description:		MFC standard function
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnOK() 
{
	//when new rate is inputed
	m_rate_edit.GetWindowText(TmpStr);
	double fTmp = atof(TmpStr);
	if((fTmp < 50) || (fTmp >1001)){
		MessageBox("Rate is out of range","ERROR",MB_OK);
		return;
	}
	apScanObject.SO_dblRate = fTmp;
	if(apScanObject.SO_dblRate > 1001)	apScanObject.SO_dblRate = 1001;
	wErr_ret = myCM30xFun.SendRate(theApp.ConectDevIDList[bDev_index],&apScanObject.SO_dblRate);
	TmpStr.Format("Set rate %5.1f return >> %s",apScanObject.SO_dblRate,ERROR_MSG[wErr_ret]);
	if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
	AddEvtLog(&TmpStr);
	CalNumOfChan();
}

/****************************************************************************
*
*   Function:			OnClose() 
*	description:		When the dialog box is about closed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnClose();
	OnEndScan();	//stop scan first
	CDialog::OnOK();
	theApp.asConfigData[bDev_index].bIsActive = FALSE;
	DestroyWindow();
}

/****************************************************************************
*
*   Function:			OnInitialization() 
*	description:		When Initialization button is clicked
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnInitialization() 
{
	// TODO: Add your control notification handler code here
	bInitializedOK = DoReInitInstance();
	if(!bInitializedOK){
		TmpStr.Format("The Device is not available");
		AddEvtLog(&TmpStr);
		UpdateWndState(FALSE);
		return;//don't do rest
	}
	TmpStr.Format("Wait for sign on...");
	AddEvtLog(&TmpStr);
	bSignOnOK = FALSE;
	bReTry = 0;
	wErr_ret = myCM30xFun.SendSignon(theApp.ConectDevIDList[bDev_index]);
	TmpStr.Format("Send SignOn Cmd >>%s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	bReTry++;
	if(wErr_ret == COMMAND_SUCCESS){
		StartOnTmChkSignOn();//start timer
	}
}

/****************************************************************************
*
*   Function:			OnPollMode() 
*	description:		Poll mode check box is clicked
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnPollMode() 
{
	// TODO: Add your control notification handler code here
	BYTE i;
	m_start_scan.SetWindowText("&Get conversion");
	m_start_scan.EnableWindow(TRUE);
	m_sys_cal.EnableWindow(TRUE);
	m_end_scan.ShowWindow(SW_HIDE);
	m_multi_chan.ShowWindow(SW_HIDE);
	m_cal_scan.ShowWindow(SW_HIDE);
	CalNumOfChan();
	m_num_scan_chan.EnableWindow(FALSE);
	m_avg_combo.EnableWindow(FALSE);
	for(i = 0; i < 8; i++){
		m_pChanReading[i]->SetWindowText("       ");//erase previous reading
		m_pChanSel[i]->EnableWindow(TRUE);
		m_pChanSel[i]->SetCheck(0);//uncheck all
	}
	m_pChanSel[bCurSelChan]->SetCheck(1);	//set chan 0 checked
	OnChComm(bCurSelChan);		
	if(!bIsM302){
		for(i = 2; i < 6; i++){
			m_pChanSel[i]->EnableWindow(FALSE);
		}
	}
}

/****************************************************************************
*
*   Function:			OnScanMode() 
*	description:		when scan mode is clicked
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnScanMode() 
{
	// TODO: Add your control notification handler code here
	BYTE i;
	m_sys_cal.EnableWindow(FALSE);
	m_start_scan.SetWindowText("&Start Scan");
	m_end_scan.ShowWindow(SW_SHOW);
	m_multi_chan.ShowWindow(SW_SHOW);
	if(m_multi_chan.GetCheck()){
		m_num_scan_chan.EnableWindow(TRUE);
		m_cal_scan.ShowWindow(SW_SHOW);
		m_cal_scan.EnableWindow(TRUE);
		for(i = 0; i < 8; i++){
			m_pChanSel[i]->EnableWindow(FALSE);
		}
		OnSelchangeNumChan();
	}else{
		for(i = 0; i < 8; i++){
			m_pChanSel[i]->EnableWindow(TRUE);
		}
		if(!bIsM302){
			for(i = 2; i < 6; i++){
				m_pChanSel[i]->EnableWindow(FALSE);
			}
		}
	}
	if(m_start_scan.IsWindowEnabled()){
		m_multi_chan.EnableWindow(TRUE);
	}else{
		m_multi_chan.EnableWindow(FALSE);
	}
	CalNumOfChan();
	m_avg_combo.EnableWindow(TRUE);
}

/****************************************************************************
*
*   Function:			OnMultiChan() 
*	description:		Multi-chan check box is clicked
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnMultiChan() 
{
	// TODO: Add your control notification handler code here
	//when select multi-channel scanning
	BYTE i;
	for(i = 0; i < 8; i++){
		m_pChanReading[i]->SetWindowText("       ");//erase previous reading
	}
	if(m_multi_chan.GetCheck()){
		//select all channels
		m_chan_sel.EnableWindow(TRUE);
		m_cal_scan.ShowWindow(SW_SHOW);
		m_cal_scan.EnableWindow(TRUE);
		m_num_scan_chan.EnableWindow(TRUE);
		CalNumOfChan();
		for(i = 0; i < 8; i++){
			m_pChanSel[i]->EnableWindow(FALSE);
		}
		OnSelchangeNumChan();
	}else{//uncheck them
		m_chan_sel.EnableWindow(FALSE);
		m_cal_scan.ShowWindow(SW_HIDE);
		m_num_scan_chan.SetCurSel(0);//'1' is selected
		m_num_scan_chan.EnableWindow(FALSE);
		for(i = 0; i < 8; i++){
			m_pChanSel[i]->SetCheck(0);
		}
		m_pChanSel[0]->SetCheck(1);
		CalNumOfChan();
		for(i = 0; i < 8; i++){
			m_pChanSel[i]->EnableWindow(TRUE);
		}
		if(!bIsM302){
			for(i = 2; i < 6; i++){
				m_pChanSel[i]->EnableWindow(FALSE);
			}
		}
	}
}

/****************************************************************************
*
*   Function:			OnSelchangeAvgCombo() 
*	description:		Avg. combo selection box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSelchangeAvgCombo() 
{
	// TODO: Add your control notification handler code here
	bChanScanAvg = 1 << m_avg_combo.GetCurSel();
}

/****************************************************************************
*
*   Function:			OnSysCal() 
*	description:		SysCal button is clicked
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSysCal() 
{
	// TODO: Add your control notification handler code here
	wErr_ret = myCM30xFun.SysCal(theApp.ConectDevIDList[bDev_index]);
	TmpStr.Format("SysCal return >> %s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();

}

/****************************************************************************
*
*   Function:			OnCalScan() 
*	description:		when click Cali. scan check box
*						Update channel selection check box
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnCalScan() 
{
	// TODO: Add your control notification handler code here
	CalNumOfChan();
}

/****************************************************************************
*
*   Function:			OnStartScan() 
*	description:		Start button is clicked
*						start to scan
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnStartScan() 
{
	// TODO: Add your control notification handler code here
	BYTE i;
	char fileName[255];
	char tm_str[80];
	time_t t;
	bNeedReadMore = FALSE;
	m_num_scan_chan.EnableWindow(FALSE);
	m_multi_chan.EnableWindow(FALSE);
	m_cal_scan.EnableWindow(FALSE);
	PrepScanObj();
	p_LCD_CDC->SetBkColor(m_bkColor0);
	p_LCD_CDC->FillRect(&LCD_RECT,&bkBrush);//clear LCD screen
	ClsScreen();
	//assign memory here /release it in stop scan
	if(m_poll_mode.GetCheck()){
		m_sys_cal.EnableWindow(TRUE);
		GetConversion();
	}else{
		m_rate_edit.EnableWindow(FALSE);
		ulScanCnt = 0;
		for(i = 0; i < 8;i++){
			usVoltAvgArrayIndex[i] = 0;
		}
		bBuffWrappedDsp = TRUE;
		m_avg_combo.EnableWindow(FALSE);
		m_scan_log_check.EnableWindow(FALSE);
		m_poll_mode.EnableWindow(FALSE);
		if(m_scan_log_check.GetCheck()){//when write log file is enabled
			if(_mkdir("M30x_LOG")){//the folder may already exist
			}
			if(bIsM302){
				sprintf(fileName,"M30x_LOG/M302_%x.txt",theApp.hMainWnd);
			}else{
				sprintf(fileName,"M30x_LOG/M301_%x.txt",theApp.hMainWnd);
			}
			pLogFile = fopen(fileName, "w");
			if(!pLogFile){
				MessageBox("Failed to open log file","ERROR",MB_OK);
				pLogFile = NULL;
			}else{
				time(&t);
				strcpy(tm_str,ctime(&t));
				fprintf(pLogFile,"Date Created :%s",tm_str);
				switch(apScanObject.SO_bScanType){
					case SINGLE_CHAN_SCAN:
						TmpStr.Format("SINGLE_CHAN_SCAN");
						break;
					case MULTI_CHAN_SCAN:
						TmpStr.Format("MULTI_CHAN_SCAN");
						break;
					case MULTI_CHAN_CAL_SCAN:
						TmpStr.Format("MULTI_CHAN_CAL_SCAN");
						break;
					case SINGLE_CHAN_DIGIN_SCAN:
						TmpStr.Format("SINGLE_CHAN_DIGIN_SCAN");
						break;
					case MULTI_CHAN_DIGIN_SCAN:
						TmpStr.Format("MULTI_CHAN_DIGIN_SCAN");
						break;
					case MULTI_CHAN_CAL_DIGIN_SCAN:
						TmpStr.Format("MULTI_CHAN_CAL_DIGIN_SCAN");
						break;
					default:
						TmpStr.Format("UNKNOWN FLAG");
						break;
				}
				TmpStr = TmpStr + " >>>>>>SCAN WITH DIGITAL INPUT";
				fprintf(pLogFile,"%s\n",TmpStr);
				fprintf(pLogFile,"\n");
				fprintf(pLogFile,"\n");
				fprintf(pLogFile,"DEV\tSCAN#\t(chan)\tVOLTAGE\t(digin)\n");
			}
		}
		m_sys_cal.EnableWindow(FALSE);
		m_start_scan.EnableWindow(FALSE);
		m_chan_sel.SetCurSel(WhatChanSel());//set the chan which is in scanning
		bIsScanning = TRUE;
		m_end_scan.EnableWindow(TRUE);
		BOOL bStartScanOK = TRUE;
		nPlot_X = 0;
		//use bDev_index as event ID 
		bStartScanOK = (wErr_ret == COMMAND_SUCCESS);
		if(!bStartScanOK) return;//don't do rest
		wErr_ret = myCM30xFun.ChangeChan(theApp.ConectDevIDList[bDev_index],WhatChanSel());
		TmpStr.Format("Set Channel return >> %s",ERROR_MSG[wErr_ret]);
		AddEvtLog(&TmpStr);
		Sleep(200);
		wErr_ret = myCM30xFun.StartScan(theApp.ConectDevIDList[bDev_index],&apScanObject);
		TmpStr.Format("Start scan return >> %s",ERROR_MSG[wErr_ret]);
		AddEvtLog(&TmpStr);
		if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
		bStartScanOK = (wErr_ret == COMMAND_SUCCESS);
		KillTimer(bDev_index);
		ulOnTimeInt = (UINT)(1000/apScanObject.SO_dblRate);
		ulOnTimeInt = ulOnTimeInt * (UINT) bNumChanScan; //more channel, slowdown
		if(!SetTimer(bDev_index,ulOnTimeInt,OnTimerProc)){
			MessageBox("Failed to set the timer",ERROR,MB_OK);
		}
		m_initialization.EnableWindow(FALSE);
		m_sys_cal.EnableWindow(FALSE);
	}
}

/****************************************************************************
*
*   Function:			OnEndScan() 
*	description:		End button is clicked
*						End to scan
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnEndScan() 
{
	// TODO: Add your control notification handler code here
	wErr_ret = myCM30xFun.EndScan(theApp.ConectDevIDList[bDev_index]);
	TmpStr.Format("EndScan return >> %s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
	EndScanBtnProc();
}

/****************************************************************************
*
*   Function:			OnSelchangeNumChan() 
*	description:		Number of channel is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSelchangeNumChan() 
{
	// TODO: Add your control notification handler code here
	BYTE i,bAllAbove;
	for(i = 0; i < 8; i++){
		m_pChanReading[i]->SetWindowText("       ");//erase previous reading
	}
	CalNumOfChan();
	bAllAbove = bNumChanScan;
	if(m_cal_scan.GetCheck()){
		if(bIsM302){
			if(bNumChanScan < 8) bAllAbove--;
		}else{
			if(bNumChanScan < 4) bAllAbove--;
		}

	}
	if(bIsM302){
		for(i = 0; i < (8 - (m_cal_scan.GetCheck() & 1)); i++){
			if(i < bAllAbove){
				m_pChanSel[i]->SetCheck(1);
			}else{
				m_pChanSel[i]->SetCheck(0);
			}
		}
		return;
	}
//for M301 only
	for(i = 0; i < (8 - (m_cal_scan.GetCheck() & 1)); i++){
		m_pChanSel[i]->SetCheck(0);
	}
	switch(bAllAbove){
		case 1:
			m_pChanSel[0]->SetCheck(1);
			break;
		case 2:
			m_pChanSel[0]->SetCheck(1);
			m_pChanSel[1]->SetCheck(1);
			break;
		case 3:
			m_pChanSel[0]->SetCheck(1);
			m_pChanSel[1]->SetCheck(1);
			m_pChanSel[6]->SetCheck(1);
			break;
		case 4:
			m_pChanSel[0]->SetCheck(1);
			m_pChanSel[1]->SetCheck(1);
			m_pChanSel[6]->SetCheck(1);
			m_pChanSel[7]->SetCheck(1);
			break;
	}
}



/****************************************************************************
*
*   Function:			OnDac0Output() 
*	description:		When click DAC0 output button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnDac0Output() 
{
	// TODO: Add your control notification handler code here
	OnDacOutputComm(0);	
}

/****************************************************************************
*
*   Function:			OnDac1Output() 
*	description:		When click DAC1 output button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnDac1Output() 
{
	// TODO: Add your control notification handler code here
	OnDacOutputComm(1);
}

/****************************************************************************
*
*   Function:			OnDac2Output() 
*	description:		When click DAC2 output button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnDac2Output() 
{
	// TODO: Add your control notification handler code here
	OnDacOutputComm(2);
}

void CScanDlg::OnDacOutputComm(BYTE bDacIndex)
{
	double fVoltageInput;
	switch(bDacIndex){
	case 0:
		m_dac_edit0.GetWindowText(TmpStr);
		fVoltageInput = atof(TmpStr);
		if(fVoltageInput > 5.0) fVoltageInput = 5.0;
		if(fVoltageInput < 0.0) fVoltageInput = 0;
		TmpStr.Format("%5.4f",fVoltageInput);
		m_dac_edit0.SetWindowText(TmpStr);
		break;
	case 1:
		m_dac_edit1.GetWindowText(TmpStr);
		fVoltageInput = atof(TmpStr);
		if(fVoltageInput > 5.0) fVoltageInput = 5.0;
		if(fVoltageInput < 0.0) fVoltageInput = 0;
		TmpStr.Format("%5.4f",fVoltageInput);
		m_dac_edit1.SetWindowText(TmpStr);
		break;
	case 2:
		m_dac_edit2.GetWindowText(TmpStr);
		fVoltageInput = atof(TmpStr);
		if(fVoltageInput > 5.0) fVoltageInput = 5.0;
		if(fVoltageInput < 0.0) fVoltageInput = 0;
		TmpStr.Format("%5.4f",fVoltageInput);
		m_dac_edit2.SetWindowText(TmpStr);
		break;
	default:
		fVoltageInput = 0;
		break;
	}
	wErr_ret = myCM30xFun.SendDACOut(theApp.ConectDevIDList[bDev_index],fVoltageInput,bDacIndex);
	TmpStr.Format("Send DAC return >> %s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
}

/****************************************************************************
*
*   Function:			GetConversion() 
*	description:		Get one conversion when in poll mode
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::GetConversion()
{
	BYTE i,j;
	wErr_ret = myCM30xFun.GetConversion(theApp.ConectDevIDList[bDev_index],&volts_tmp[WhatChanSel()]);
	TmpStr.Format("Conversion return >> %s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
	j = WhatChanSel();
	if(wErr_ret == COMMAND_SUCCESS){
		for(i = 0 ;i < 8; i++){
			if(i == j){
		 		TmpStr.Format("%07.6f",volts_tmp[j]);
			}else{
		 		TmpStr.Format("             ");
			}
			m_pChanReading[i]->SetWindowText(TmpStr);
		}
		UpdateDigiIn(myCM30xFun.bLastDigin);
	}else{//something is wrong
		UpdateWndState(FALSE);
	}
	TmpStr.Format("%u",apScanObject.SO_uiPointsInBuffer);//display data points in buffer
	m_data_points.SetWindowText(TmpStr);
}

/****************************************************************************
*
*   Function:			UpdateDigiOut() 
*	description:		Update digital output
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::UpdateDigiOut()
{
	BYTE i,bWhatOut = 0;
	for(i = 0; i < 8; i++){
		bWhatOut = bWhatOut | m_pDigiOut[i]->GetCheck() << i;
	}
	wErr_ret = myCM30xFun.SendDigitalOut(theApp.ConectDevIDList[bDev_index],bWhatOut);
	TmpStr.Format("Send Digital out >> %s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
}

/****************************************************************************
*
*   Function:			OnSelChangVoltDivComb() 
*	description:		When volt/div combo box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSelChangVoltDivComb()
{
	BYTE i,j;
	j = m_volt_div_combo.GetCount() - m_volt_div_combo.GetCurSel() - 1;
	fDotsPerVolt = LCD_RECT.bottom/10;//now fDotsPerVolt = dots per 1uV
	for(i = 0; i < j; i++){
		fDotsPerVolt = fDotsPerVolt * 10;
	}
	ClsScreen();
}

/****************************************************************************
*
*   Function:			OnSelChangDcAcComb() 
*	description:		When AC/DC combo box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnSelChangDcAcComb()
{
	bIsAC = (m_dc_ac_sel.GetCurSel() == 1);
	ClsScreen();
}


/****************************************************************************
*
*   Function:			UpdateDigiIn() 
*	description:		Update digital input
*	input:				BYTE bDigiIn
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::UpdateDigiIn(BYTE bDigiIn)
{
	BYTE bReverse = ~bDigiIn;
	if(bIsM302) bReverse = bReverse & 0x0f;//only 4 bits for M302
	if(bReverse & 1){
		m_led_gray1.ShowWindow(SW_HIDE);
		m_led_red1.ShowWindow(SW_SHOW);
	}else{
		m_led_red1.ShowWindow(SW_HIDE);
		m_led_gray1.ShowWindow(SW_SHOW);
	}
	if(bReverse & 2){
		m_led_gray2.ShowWindow(SW_HIDE);
		m_led_red2.ShowWindow(SW_SHOW);
	}else{
		m_led_red2.ShowWindow(SW_HIDE);
		m_led_gray2.ShowWindow(SW_SHOW);
	}
	if(bReverse & 4){
		m_led_gray3.ShowWindow(SW_HIDE);
		m_led_red3.ShowWindow(SW_SHOW);
	}else{
		m_led_red3.ShowWindow(SW_HIDE);
		m_led_gray3.ShowWindow(SW_SHOW);
	}
	if(bReverse & 8){
		m_led_gray4.ShowWindow(SW_HIDE);
		m_led_red4.ShowWindow(SW_SHOW);
	}else{
		m_led_red4.ShowWindow(SW_HIDE);
		m_led_gray4.ShowWindow(SW_SHOW);
	}
	if(bReverse & 16){
		m_led_gray5.ShowWindow(SW_HIDE);
		m_led_red5.ShowWindow(SW_SHOW);
	}else{
		m_led_red5.ShowWindow(SW_HIDE);
		m_led_gray5.ShowWindow(SW_SHOW);
	}
	if(bReverse & 32){
		m_led_gray6.ShowWindow(SW_HIDE);
		m_led_red6.ShowWindow(SW_SHOW);
	}else{
		m_led_red6.ShowWindow(SW_HIDE);
		m_led_gray6.ShowWindow(SW_SHOW);
	}
	if(bReverse & 64){
		m_led_gray7.ShowWindow(SW_HIDE);
		m_led_red7.ShowWindow(SW_SHOW);
	}else{
		m_led_red7.ShowWindow(SW_HIDE);
		m_led_gray7.ShowWindow(SW_SHOW);
	}
	if(bReverse & 128){
		m_led_gray8.ShowWindow(SW_HIDE);
		m_led_red8.ShowWindow(SW_SHOW);
	}else{
		m_led_red8.ShowWindow(SW_HIDE);
		m_led_gray8.ShowWindow(SW_SHOW);
	}
}

/****************************************************************************
*
*   Function:			OnChComm(BYTE bCHClicked) 
*	description:		When click one of eight channel selection check box
*	input:				BYTE bCHClicked
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::OnChComm(BYTE bCHClicked)
{
	BYTE i;
	//when single channel in scan mode or in poll mode
	//only one channel should be selected
	bCurSelChan = bCHClicked;
	if(!m_multi_chan.GetCheck() || 	m_poll_mode.GetCheck()){
		ulScanCnt = 0;//start over
		for(i = 0; i < 8;i++){
			usVoltAvgArrayIndex[i] = 0;
		}
		wErr_ret = myCM30xFun.ChangeChan(theApp.ConectDevIDList[bDev_index],bCHClicked);
		TmpStr.Format("Set Channel %d return >> %s",bCHClicked, ERROR_MSG[wErr_ret]);
		AddEvtLog(&TmpStr);
		for(i = 0; i < 8; i++){
			m_pChanReading[i]->SetWindowText("       ");
			if(i == bCHClicked){
				m_pChanSel[i]->SetCheck(1);
				//we need to clear the buffer for new channel data
				if(bIsScanning){
					wErr_ret = myCM30xFun.ChangeChan(theApp.ConectDevIDList[bDev_index],bCHClicked);
					TmpStr.Format("Set Channel return >> %s",ERROR_MSG[wErr_ret]);
					AddEvtLog(&TmpStr);
					if(wErr_ret != COMMAND_SUCCESS){
						if(bIsScanning) OnEndScan();
					}
				}
			}else{
				m_pChanSel[i]->SetCheck(0);
			}
		}
	}
	//when multi channel scan mode, these selection are disabled
	CalNumOfChan();
}

/****************************************************************************
*
*   Function:			WhatChanSel() 
*	description:		check which channel is selected when
*						in single scan or poll mode
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
BYTE CScanDlg::WhatChanSel()
{
	BYTE i;
	for(i = 0; i < 8; i++){
		if(m_pChanSel[i]->GetCheck()) return i;
	}
	return 0xff;
}

/****************************************************************************
*
*   Function:			PlotWnd(double fVoltage)
*	description:		Draw voltage curve window
*	input:				double fVoltage
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::PlotWnd(double fVoltage)
{
	INT nPlot_Y;
	if((nPlot_X < 0) || (nPlot_X > (UINT)LCD_RECT.right)){
		nPlot_X = 0;
	}
	p_LCD_CDC->SetPixel(nPlot_X,nPrev_Y[nPlot_X],m_bkSaved);//erase the previous drawing
	if(bIsAC){
		nPlot_Y = (INT)((fVoltage + fOffSet) * fDotsPerVolt);
	}else{
		nPlot_Y = (INT)((-fVoltage + fOffSet) * fDotsPerVolt);
	}
	nPlot_Y = ulCenter + nPlot_Y;
	if(nPlot_Y >= (INT)LCD_RECT.bottom) nPlot_Y = (INT)LCD_RECT.bottom - 1;
	if(nPlot_Y < 0) nPlot_Y = 0;
	m_bkSaved = p_LCD_CDC->GetPixel(nPlot_X, nPlot_Y);//save this first
	p_LCD_CDC->SetPixel(nPlot_X, nPlot_Y, RGB(0,0,0));//black pixel
	nPrev_Y[nPlot_X] = nPlot_Y;
	nPlot_X++;
	if(nPlot_X >= (UINT)LCD_RECT.right){
		nPlot_X = 0;
	}
	if(bIsAC){
		fOffSet = -fVoltage;//remember this for next time comparasion
	}else{
		fOffSet = 0;
	}
}


/****************************************************************************
*
*   Function:			DoReInitInstance()
*	description:		GetDeviceIDlist and re-initInstance in case one device 
*						is re-connected
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
BOOLEAN CScanDlg::DoReInitInstance()
{
	BYTE i;
	USHORT usTmpDevList[MAX_NUM_DEVICE];
	if(!theApp.pDLL_GetDeviceIDList()){
		TmpStr.Format("Call pDLL_GetDeviceIDList failed ");
		AddEvtLog(&TmpStr);
	}
	for(i = 0; i < MAX_NUM_DEVICE;i++){
		usTmpDevList[i] = theApp.ConectDevIDList[i];//save this first
		if(i != bDev_index)		theApp.ConectDevIDList[i] = 0;
		//make all device ID = 0 except the one need to be
		//re initialized
	}
	if(!theApp.pDLL_InstanceInitDeviceList(0)){
		TmpStr.Format("Call InstanceInit failed");
		AddEvtLog(&TmpStr);
	}
	//restore them back
	BOOLEAN bDevIsThere = FALSE;
	for(i = 0; i < MAX_NUM_DEVICE;i++){
		if(theApp.ConectDevIDList[i]) bDevIsThere = TRUE;
		theApp.ConectDevIDList[i] = usTmpDevList[i];
	}
	return bDevIsThere;
}

/****************************************************************************
*
*   Function:			ScheduleAction_O(USHORT bDev_index)
*	description:		When time is up do on time scheduled action
*	input:				USHORT bDev_index
*   output:				Update all readings and display them
*	global variable:	
****************************************************************************/
void CScanDlg::ScheduleAction_O(USHORT bDev_index)
{
	BYTE i,bChan_ID = 0,bChanSel;
	BYTE bWhichChan;
	UINT j, ulDataPoints;
	BYTE	bIsCalScan = m_cal_scan.GetCheck() & 1;//check if it is cal. scan
	if(!bNeedReadMore){
		//calculate ulNumPointsToTransfer
		ulNumPointsToTransfer = ((UINT)fScanRate * (UINT)apScanObject.SO_bScanArg) / 10;
		if(ulNumPointsToTransfer < 8) ulNumPointsToTransfer = 8;
		ulNumPointsToTransfer = (UINT)(ulNumPointsToTransfer /bNumChanScan)*bNumChanScan;
	}
	if(!theApp.pDLL_ReadScanDataWithDigin(theApp.ConectDevIDList[bDev_index],myCM30xFun.p_ulRawCntsBuff,
		myCM30xFun.p_bDiginBuff, &bChan_ID, ulNumPointsToTransfer, &apScanObject)){
		//It could be device error OR data is not ready
		CheckScanFlg();
		goto EXIT_ONTIMER;
	}
	CheckScanFlg();
	if((apScanObject.SO_uiPointsInBuffer >= 8190l) && bBuffWrappedDsp){
		TmpStr.Format("Memory buffer wrapped");
		AddEvtLog(&TmpStr);
		bBuffWrappedDsp = FALSE;//Only display once
	}
	TmpStr.Format("%u",apScanObject.SO_uiPointsInBuffer);//display data points in buffer
	m_data_points.SetWindowText(TmpStr);
	if(apScanObject.SO_uiStatus & SCAN_CHECKSUM_ERROR) 	goto EXIT_ONTIMER;
	UpdateDigiIn(apScanObject.SO_bDigitalInput);//update digital input
	//check data points in buffer if data point remained in buffer is still
	ulDataPoints = ulNumPointsToTransfer / bNumChanScan;
	if(!m_multi_chan.GetCheck()){
		//single chan scan pass 0 to the call
		//do average checking
		bChanSel = WhatChanSel(); 
		for(j = 0 ;j < ulNumPointsToTransfer; j++){
			fVoltBuff[bChanSel][j] = CONV_VOLT((INT)myCM30xFun.ulRawCntsBuff[j]);
		}
		//single channel average calculation
		CalRunningAvg(ulNumPointsToTransfer,bChanScanAvg,bChanSel);
		//to do average calculation based on bChanScanAvg
		volts_tmp[bChanSel] = fVoltBuff[bChanSel][0];//display only first data
 		TmpStr.Format("%07.6f",volts_tmp[bChanSel]);
		m_pChanReading[bChanSel]->SetWindowText(TmpStr);
		for(j = 0 ;j < ulDataPoints; j++){
			PlotWnd(fVoltBuff[bChanSel][j]);
			ulScanCnt++;
			WriteDataLogFile(bChanSel,j,1);//single channel writing
		}
		if(pLogFile){
			if(!fprintf(pLogFile,"\n")){
				fclose(pLogFile);//when failed to write
				pLogFile = NULL;//when failed to write
				goto EXIT_ONTIMER;
			}
		}
		goto EXIT_ONTIMER;
	}
	//multi-chan scan just simply read ALL channel data
	for(j = 0 ;j < ulDataPoints; j++){
		if(bIsCalScan){//when do cal. scan, substract offset from all selected channels
			fVoltBuff[bNumChanScan - 1][j] = CONV_VOLT((INT)myCM30xFun.ulRawCntsBuff[j * bNumChanScan + bNumChanScan - 1]);
			for(i = 0; i < bNumChanScan - 1; i++){
				fVoltBuff[i][j] = CONV_VOLT((INT)myCM30xFun.ulRawCntsBuff[j * bNumChanScan + i]);
				fVoltBuff[i][j] = fVoltBuff[i][j] - fVoltBuff[bNumChanScan - 1][j];//substract offset
			}
		}else{
			for(i = 0; i < bNumChanScan; i++){
				fVoltBuff[i][j] = CONV_VOLT((INT)myCM30xFun.ulRawCntsBuff[j * bNumChanScan + i]);
			}
		}
	}
	for(i = 0; i < bNumChanScan; i++){
		CalRunningAvg(ulDataPoints,bChanScanAvg,i);
	}
	if(bIsM302){
		for(i = 0; i < (bNumChanScan - bIsCalScan); i++){
			TmpStr.Format("%07.6f",fVoltBuff[i][0]);//display 1st data
			m_pChanReading[i]->SetWindowText(TmpStr);//all channels
		}
		if(bIsCalScan){
			TmpStr.Format("%07.6f",fVoltBuff[bNumChanScan - 1][0]);
			m_pChanReading[7]->SetWindowText(TmpStr);
		}
	}else{
		TmpStr.Format("%07.6f",fVoltBuff[0][0]);
		m_pChanReading[0]->SetWindowText(TmpStr);//always channel 0
		if(apScanObject.SO_bScanArg != 1){
			switch(apScanObject.SO_bScanArg){
				case 2:
					TmpStr.Format("%07.6f",fVoltBuff[1][0]);
					m_pChanReading[1]->SetWindowText(TmpStr);
					break;
				case 3:
					TmpStr.Format("%07.6f",fVoltBuff[1][0]);
					m_pChanReading[1]->SetWindowText(TmpStr);
					TmpStr.Format("%07.6f",fVoltBuff[2][0]);
					m_pChanReading[6]->SetWindowText(TmpStr);
					break;
				default:
					TmpStr.Format("%07.6f",fVoltBuff[1][0]);
					m_pChanReading[1]->SetWindowText(TmpStr);
					TmpStr.Format("%07.6f",fVoltBuff[2][0]);
					m_pChanReading[6]->SetWindowText(TmpStr);
					TmpStr.Format("%07.6f",fVoltBuff[3][0]);
					m_pChanReading[7]->SetWindowText(TmpStr);
					break;
			}
		}
		//when do caliberation scan, Chan7 is always selected
		if(bIsCalScan){
			//get cal. data 
			TmpStr.Format("%07.6f",fVoltBuff[bNumChanScan - 1][0]);
			m_pChanReading[7]->SetWindowText(TmpStr);
		}
	}
	bWhichChan = m_chan_sel.GetCurSel();
	if(!bIsM302){
		if(bWhichChan == 6) bWhichChan = 2;
		if(bWhichChan == 7) bWhichChan = 3;
	}
	if(((bWhichChan >= 0) && (bWhichChan < 4)) || bIsM302){
		for(j = 0 ;j < ulDataPoints; j++){
			PlotWnd(fVoltBuff[bWhichChan][j]);
			ulScanCnt++;
			WriteDataLogFile(0,j,bNumChanScan);
			//multi-channel writing
		}
		if(pLogFile){
			if(!fprintf(pLogFile,"\n")){
				fclose(pLogFile);//when failed to write
				pLogFile = NULL;//when failed to write
				goto EXIT_ONTIMER;
			}
		}
	}
EXIT_ONTIMER:
	if(apScanObject.SO_uiPointsInBuffer > (2 * ulNumPointsToTransfer)){
		bNeedReadMore = TRUE;
		ulNumPointsToTransfer = apScanObject.SO_uiPointsInBuffer - ulNumPointsToTransfer;
		if(ulNumPointsToTransfer > MAX_DATA_POINTS) ulNumPointsToTransfer = MAX_DATA_POINTS;
		ulNumPointsToTransfer = (UINT)(ulNumPointsToTransfer /bNumChanScan)*bNumChanScan;
	}else{
		bNeedReadMore = FALSE;
	}
}


void CScanDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	OnClose();
}

	

void CScanDlg::CalNumOfChan()
{
	if(m_poll_mode.GetCheck()){
		bNumChanScan = 1;
		TmpStr.Format("Scanning rate:       ");
	}else{		
		if(m_multi_chan.GetCheck()){
			bNumChanScan = m_num_scan_chan.GetCurSel() + 1;
			if(m_cal_scan.GetCheck()){
				bNumChanScan++;
				m_pChanSel[7]->SetCheck(1);
			}else{
				if(((bNumChanScan != 8) && bIsM302) ||	(!bIsM302 && (bNumChanScan != 4)))	m_pChanSel[7]->SetCheck(0);
			}
			if(bIsM302){
				if(bNumChanScan > 8) bNumChanScan = 8;
			}else{
				if(bNumChanScan > 4) bNumChanScan = 4;
			}
			fScanRate = (apScanObject.SO_dblRate / (double)bNumChanScan / 5);
		}else{
			bNumChanScan = 1;
			fScanRate = (apScanObject.SO_dblRate);
		}
		TmpStr.Format("Scanning rate:%5.1f",fScanRate);
		m_scan_rate.SetWindowText(TmpStr);
		fSecPerDiv = (double) ulDotsPerScaleX / fScanRate;
		TmpStr.Format("X:%4.2fSec/Div",fSecPerDiv);
		m_sec_p_div.SetWindowText(TmpStr);
	}
	TmpStr.Format("%5.1f",apScanObject.SO_dblRate);
	m_rate_edit.SetWindowText(TmpStr);
}

/****************************************************************************
*
*   Function:			AddEvtLog(CString *m_pEvtLog)
*	description:		Add log information to the event list window
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::AddEvtLog(CString *m_pEvtLog)
{
	CString stmstr;
	time_t ltime;
	time( &ltime );
 	CTime TimeStamp(ltime);
	stmstr= TimeStamp.Format("%H:%M:%S ");  
	stmstr += *m_pEvtLog;
	m_evt_log_wnd.AddString(stmstr);
	m_evt_log_wnd.SetCurSel(ulTotalLogLines);
	ulTotalLogLines++;
}



void CScanDlg::MyInit()
{
	OnInitialization();
}

/****************************************************************************
*
*   Function:			CalRunningAvg(UINT ulPoints, BYTE bAvg, BYTE bChanSel)
*	description:		Calculate running average
*	input:				UINT ulPoints, BYTE bAvg,BYTE bChanSel
*   output:				fVoltBuff is assigned new average value
*	global variable:	
****************************************************************************/
void CScanDlg::CalRunningAvg(UINT ulPoints, BYTE bAvg, BYTE bChanSel)
{
	if(!bAvg) return;//in case divided by zero
	if(!ulScanCnt){
		for(BYTE k = 0; k < bAvg; k++){
			fVoltAvgTmp[bChanSel][k] = fVoltBuff[bChanSel][0];
		}
		fVoltAvgTotal[bChanSel] = fVoltBuff[bChanSel][0] *  bAvg;
	}
	for(UINT j = 0; j < ulPoints; j++){
		fVoltAvgTotal[bChanSel] = fVoltAvgTotal[bChanSel] + fVoltBuff[bChanSel][j] - fVoltAvgTmp[bChanSel][usVoltAvgArrayIndex[bChanSel]];
		fVoltAvgTmp[bChanSel][usVoltAvgArrayIndex[bChanSel]] = fVoltBuff[bChanSel][j];
		fVoltBuff[bChanSel][j] = fVoltAvgTotal[bChanSel] / bAvg;
		usVoltAvgArrayIndex[bChanSel] ++;
		if(usVoltAvgArrayIndex[bChanSel] >= bAvg) usVoltAvgArrayIndex[bChanSel] = 0;
	}
}



void CScanDlg::EndScanBtnProc()
{
	KillTimer(bDev_index);
	if(pLogFile) fclose(pLogFile); //close logfile 
	bIsScanning = FALSE;
	m_scan_log_check.EnableWindow(TRUE);
	m_avg_combo.EnableWindow(TRUE);
	m_poll_mode.EnableWindow(TRUE);
	m_initialization.EnableWindow(TRUE);
	m_sys_cal.EnableWindow(TRUE);
	m_start_scan.EnableWindow(TRUE);
	m_end_scan.EnableWindow(FALSE);
	m_multi_chan.EnableWindow(TRUE);
	if(m_multi_chan.GetCheck()){
		m_cal_scan.ShowWindow(SW_SHOW);
		m_cal_scan.EnableWindow(TRUE);
	}
	m_rate_edit.EnableWindow(TRUE);
	if(m_multi_chan.GetCheck()){
		m_num_scan_chan.EnableWindow(TRUE);
	}else{
		m_num_scan_chan.EnableWindow(FALSE);
	}
}



/****************************************************************************
*
*   Function:			StartOnTmChkPwr
*	description:		Start checking power supply for M30x regularly
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::StartOnTmChkPwr()
{
//	if(!m_poll_mode.GetCheck()) return;//if not polled mode return
	if(bIsScanning) return;//if not polled mode return
	//start timer with 3 seconds interval, nIDEvent = dialog box ID + 256
	if(!SetTimer((UINT)(bDev_index | 0x100),3000,OnTimerProc)){
		MessageBox("Failed to set the timer",ERROR,MB_OK);
	}
}


/****************************************************************************
*
*   Function:			StartOnTmChkSignOn()
*	description:		Start checking power supply for M30x regularly
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::StartOnTmChkSignOn()
{
	//start timer with 3 seconds interval, nIDEvent = dialog box ID + 256
	if(!SetTimer((UINT)(bDev_index | 0x200),3000,OnTimerProc)){
		MessageBox("Failed to set the timer",ERROR,MB_OK);
	}
}


/****************************************************************************
*
*   Function:			ScheduleAction_II(USHORT bDev_index)
*	description:		Check signon returns OK
*	input:				bDev_index
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::ScheduleAction_II(USHORT bDev_index)
{
	wErr_ret = myCM30xFun.CheckSignon(theApp.ConectDevIDList[bDev_index]);
	TmpStr.Format("CheckSignOn >>%s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	if(wErr_ret == SIGN_ON_SUCCESS){
		KillTimer((UINT)(bDev_index | 0x200));
		bSignOnOK = TRUE;
		if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
		bInitializedOK = (bSignOnOK == TRUE);
		if(!bInitializedOK){
			UpdateWndState(FALSE);
			return;//don't do the rest
		}
		wErr_ret = myCM30xFun.SendRate(theApp.ConectDevIDList[bDev_index],&apScanObject.SO_dblRate);
		TmpStr.Format("Set rate %5.1f return >> %s",apScanObject.SO_dblRate,ERROR_MSG[wErr_ret]);
		AddEvtLog(&TmpStr);
		if(wErr_ret == DEV_NO_POWER) StartOnTmChkPwr();
		bInitializedOK = (wErr_ret == COMMAND_SUCCESS);
		if(theApp.asConfigData[bDev_index].bChan < 8){
			OnChComm(theApp.asConfigData[bDev_index].bChan);
		}else{
			OnChComm(0);//chan 0 for default
		}
		OnSysCal();
		UpdateWndState(TRUE);
		return;
	}
	bReTry++;
	if(bReTry > RETRY_MAX){
		KillTimer((UINT)(bDev_index | 0x200));//stop the process
		return;
	}
	wErr_ret = myCM30xFun.SendSignon(theApp.ConectDevIDList[bDev_index]);
	TmpStr.Format("Send SignOn Cmd >>%s",ERROR_MSG[wErr_ret]);
	AddEvtLog(&TmpStr);
	if(wErr_ret != COMMAND_SUCCESS){
		KillTimer((UINT)(bDev_index | 0x200));//stop the process
		return;
	}
}

/****************************************************************************
*
*   Function:			ScheduleAction_I(USHORT bDev_index)
*	description:		Check if M301 is restored power
*	input:				bDev_index
*   output:				
*	global variable:	
****************************************************************************/
void CScanDlg::ScheduleAction_I(USHORT bDev_index)
{
	BYTE i;
	wErr_ret = myCM30xFun.CheckPower(theApp.ConectDevIDList[bDev_index]);
	if(wErr_ret == COMMAND_SUCCESS){
	// Power is restored back
		TmpStr.Format("Power is restored");
		AddEvtLog(&TmpStr);
		KillTimer((UINT)(bDev_index | 0x100));
		if(m_poll_mode.GetCheck()){
			UpdateWndState(TRUE);
			for(i = 0; i < 8; i++){
				if(m_pChanSel[i]->GetCheck()){
					OnChComm(i);
					break;
				}
			}
		}else{//scan mode
			UpdateWndState(FALSE);
#if 0
			if(m_multi_chan.GetCheck()){
				for(i = 0; i < 8; i++){
					m_pChanSel[i]->EnableWindow(FALSE);
				}
			}
#endif
		}
		return;
	}
	if(wErr_ret == RESET_DEV_FAILED){
		KillTimer((UINT)(bDev_index | 0x100));
	}
	if(wErr_ret == SEND_CMD_FAILED){
		TmpStr.Format("SEND_CMD_FAILED");
		AddEvtLog(&TmpStr);
	}
	UpdateWndState(FALSE);
}
